

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  Red
#property indicator_minimum 0



extern double Alpha = 0.07;

//
//
//
//
//

double DeltaPhase[];
double CPeriod[];
double Smooth[];
double Cycle[];
double Q1[];
double I1[];
double InstPeriod[];
double P[];
int median = 5;

//
//
//
//
//

int init() 
{
    IndicatorBuffers(8); 
    SetIndexBuffer(0,CPeriod);
    SetIndexBuffer(1,Smooth);
    SetIndexBuffer(2,Cycle);
    SetIndexBuffer(3,Q1);
    SetIndexBuffer(4,I1);
    SetIndexBuffer(5,DeltaPhase);
    SetIndexBuffer(6,InstPeriod);
    SetIndexBuffer(7,P);
         
    IndicatorShortName("Cycle Period [" + DoubleToStr(Alpha, 2) + "]");
    return (0);
}
  
int start() {
    int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
    
    //
    //
    //
    //
    //
    
    for(int i=limit; i>=0; i--)
    {
        P[i]      = iMA(NULL,0,1,0,MODE_SMA,PRICE_MEDIAN,i);
        Smooth[i] = (P[i] + 2.0 * P[i+1] + 2.0 * P[i+2] + P[i+3]) / 6.0;
        Cycle[i]  = (1.0-0.5*Alpha)*(1.0-0.5*Alpha)*(Smooth[i]-2*Smooth[i+1]+Smooth[i+2])+ 2.0*(1.0-Alpha)*Cycle[i+1]
            - (1.0 - Alpha) * (1.0 - Alpha) * Cycle[i + 2];
        if (i > Bars - 8) { Cycle[i] = (P[i] - 2.0 * P[i+1] + P[i+2]) / 4.0;   }
        Q1[i] = (0.0962 * Cycle[i]+0.5769 * Cycle[i+2]-0.5769*Cycle[i+4]-0.0962*Cycle[i+6])* (0.5+0.08*InstPeriod[i+1]);
        I1[i] = Cycle[i+3];
        if (Q1[i] != 0.0 && Q1[i+1] != 0.0) {
           DeltaPhase[i] = (I1[i] / Q1[i] - I1[i+1] / Q1[i+1])/ (1.0+I1[i]*I1[i+1] / (Q1[i] * Q1[i+1]));
        }
        DeltaPhase[i] = MathMax(0.1,DeltaPhase[i]);
        DeltaPhase[i] = MathMin(1.1,DeltaPhase[i]);
        double MedianDelta, DC;
        double M[];
        ArrayResize(M, median);
        ArrayCopy(M, DeltaPhase, 0, i, median);
        ArraySort(M);
        if (median % 2 == 0) { MedianDelta = (M[median / 2] + M[(median / 2) + 1]) / 2.0; } 
        else {                 MedianDelta = M[median / 2]; }
        if (MedianDelta == 0.0) { DC = 15.0; } 
        else {                    DC = 6.28318 / MedianDelta + 0.5;
        }
        InstPeriod[i] = 0.33 * DC + 0.67 * InstPeriod[i+1];
        CPeriod[i]    = 0.15 * InstPeriod[i] + 0.85 * CPeriod[i+1];
    }
    return (0);
}

